.386
.model flat, stdcall
option casemap:none

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
include    \masm32\include\comctl32.inc

includelib   \masm32\lib\user32.lib
includelib   \masm32\lib\kernel32.lib
includelib   \masm32\lib\comctl32.lib

assume   fs:flat

WndProc      PROTO :DWORD,:DWORD,:DWORD,:DWORD
AboutProc      PROTO :DWORD,:DWORD,:DWORD,:DWORD
strdec2bin   PROTO :DWORD,:DWORD ; define string to binary prototype

.data

       dlgname         db "xconv",0 ; dialogbox name
       dlgabout	       db "aboutbox",0 ; dialogbox name

       MsgAbout        db "X-Convertor v1.0  2005 by TDC and BoR0",13,10,10 ; about message
                       db "Coded by	: TDC and BoR0",13,10
                       db "Version		: 1.0",13,10
                       db "Release date	: 18-08-2005",13,10
                       db " ",13,10
		       db "X-Convertor converts up to 4KB each convert.",13,10,0

      UsersInput       db "Your input", 0 ; text
      ProgsOutput      db "Program output", 0 ; text

      HEX_PRE db "%X", 32, 0 ; prefix hex, 32 for space, 0 to end
      DEC_PRE db "%d", 32, 0 ; prefix hex, 32 for space, 0 to end

      HEX             db "Hex", 0 ; mode
      DECI            db "Decimal", 0 ; mode
      BINA            db "Binary", 0 ; mode

.data?

hEdit1          dd ? ; handle first editbox
hEdit2          dd ? ; handle second editbox
hEdit3          dd ? ; handle third editbox

hInstance       dd ? ; handle for instance
hIcon           dd ? ; handle for icon

UserInput       db ? ; users input
ProgOutput      db 4096 dup(?) ; program output, max 4KB

Mode            db 2 dup(?) ; current mode

isbin dd ? ; binary pointer
buffer db 32 dup(?) ; buffer
mybuffer db 4096 dup(?) ; total converted string
revbuf db 32 dup(?) ; buffer

.code

start:

invoke InitCommonControls ; xp style (file needed = xconv.exe.manifest)
invoke GetModuleHandle, NULL ; get instance
mov hInstance, eax ; save instance
invoke DialogBoxParam,hInstance,ADDR dlgname,NULL,ADDR WndProc,NULL ; start dialogbox
invoke ExitProcess,eax ; exit

WndProc proc hWin   :DWORD,
           uMsg   :DWORD,
           wParam :DWORD,
           lParam :DWORD

.if uMsg == WM_INITDIALOG

invoke LoadIcon,hInstance,100 ; load icon into eax
invoke SendMessage,hWin,WM_SETICON,ICON_BIG,eax ; set it

invoke GetDlgItem,hWin,107 ; get handle
mov hEdit1, eax ; save handle

invoke GetDlgItem,hWin,115 ; get handle
mov hEdit2, eax ; save handle

invoke GetDlgItem,hWin,114 ; get handle
mov hEdit3, eax ; save handle

invoke SetDlgItemText,hWin,107,offset UsersInput ; set text
invoke SetDlgItemText,hWin,115,offset ProgsOutput ; set text

mov byte ptr [Mode], 01h ; set mode
invoke SetDlgItemText, hWin, 114, offset HEX ; set text

    .elseif uMsg == WM_COMMAND

           .if wParam == 109

              cmp byte ptr [Mode], 00h ; check which mode
              je hex_mode

              cmp byte ptr [Mode], 01h ; check which mode
              je dec_mode

              cmp byte ptr [Mode], 02h ; check which mode
              je bin_mode

              hex_mode:

                      mov byte ptr [Mode], 01h ; set mode
                      invoke SetDlgItemText, hWin, 114, offset HEX

              jmp exit

              dec_mode:

                      mov byte ptr [Mode], 02h ; set mode
                      invoke SetDlgItemText, hWin, 114, offset DECI

              jmp exit

              bin_mode:

                      mov byte ptr [Mode], 00h ; set mode
                      invoke SetDlgItemText, hWin, 114, offset BINA

              jmp exit

           .elseif  wParam == 110

              invoke GetDlgItemText,hWin,107,offset UserInput,4096
              cmp byte ptr [Mode], 00h
              je conv_bin

              cmp byte ptr [Mode], 01h
              je conv_hex

              cmp byte ptr [Mode], 02h
              je conv_deci

	      ;**** HEX CONVERT ROUTINE ****
              conv_hex:
                      push ebx
                      push esi
                      invoke lstrlen, ADDR UserInput
                      mov esi, eax
                      invoke RtlZeroMemory, ADDR mybuffer, 4096 ; empty buffer
                                  xor ebx, ebx
                                  dec ebx
                                  xor eax, eax

                                  loopconv1:
                                  inc ebx

                                  xor eax, eax
                                  mov al, byte ptr [UserInput+ebx]

                      invoke wsprintf, ADDR buffer, ADDR HEX_PRE, eax ; buffer = 5dup(0)
                      invoke lstrcat, ADDR mybuffer, ADDR buffer ; mybuffer db 512 dup(0)

                      cmp ebx, esi
                      je set_text

                      jmp loopconv1

	      ;**** DECIMAL CONVERT ROUTINE ****
              conv_deci:
push ebx
push esi
                      invoke RtlZeroMemory, ADDR mybuffer, 4096 ; empty buffer
                                  xor ebx, ebx
                                  dec ebx

                                  invoke lstrlen, ADDR UserInput

                                  mov esi, eax

                      loopconv2:
                                  inc ebx

                                  xor eax, eax
                                  mov al, byte ptr [UserInput+ebx]

                      invoke wsprintf, ADDR buffer, ADDR DEC_PRE, eax ; buffer = 5dup(0)
                      invoke lstrcat, ADDR mybuffer, ADDR buffer ; mybuffer db 512 dup(0)

                      cmp ebx, esi
                      je set_text

                      jmp loopconv2

	      ;**** BINARY CONVERT ROUTINE ****
              conv_bin:
                      push ebx
                      push esi
                      invoke RtlZeroMemory, ADDR mybuffer, 4096 ; empty buffer
xor ebx, ebx
dec ebx
                      invoke lstrlen, ADDR UserInput
                      mov esi, eax
mov byte ptr [isbin], 1

loopconv3:
                      invoke RtlZeroMemory, ADDR buffer, 32

inc ebx

movzx edx, byte ptr [UserInput+ebx]
invoke strdec2bin, ADDR buffer, edx
mov byte ptr [buffer+8], 32

; put bits in reverse order
mov cl, byte ptr [buffer]
mov ch, byte ptr [buffer+7]
mov byte ptr [buffer], ch
mov byte ptr [buffer+7], cl

mov cl, byte ptr [buffer+1]
mov ch, byte ptr [buffer+6]
mov byte ptr [buffer+1], ch
mov byte ptr [buffer+6], cl

mov cl, byte ptr [buffer+2]
mov ch, byte ptr [buffer+5]
mov byte ptr [buffer+2], ch
mov byte ptr [buffer+5], cl

mov cl, byte ptr [buffer+3]
mov ch, byte ptr [buffer+4]
mov byte ptr [buffer+3], ch
mov byte ptr [buffer+4], cl

invoke lstrcat, ADDR mybuffer, ADDR buffer

cmp ebx, esi
je set_text
                      jmp loopconv3

              set_text:
                      invoke lstrlen, ADDR mybuffer
cmp byte ptr [isbin], 1 ; binary?
jne NONBINARY
sub eax, 7 ; binary, so sub extra 7
mov byte ptr [isbin], 0
NONBINARY:
                      sub eax, 3 ; no binary, so sub only 3
                      mov byte ptr [mybuffer+eax], 0 ; point to end and terminate it with 0 byte

              pop esi
              pop ebx
              invoke SetWindowText,hEdit2, offset mybuffer ; set output text
              jmp clean_it

              clean_it:
              mov ProgOutput, 00h ; end output string for next convert
              jmp exit

           .elseif  wParam == 111

		invoke DialogBoxParam,hInstance,ADDR dlgabout,hWin,ADDR AboutProc,NULL ; display about box

           .elseif  wParam == 112

              invoke EndDialog,hWin,NULL

           .elseif wParam == 113

invoke GetDlgItemText, hWin, 115, ADDR ProgOutput, SIZEOF ProgOutput
;hEdit2 changed to hWnd, because hEdit2 == 115, we need as the first param the windowhandle (hWnd) and not the edit handle. The edit handle is the 2nd param, ie. 115

    .IF eax != 0
      INVOKE OpenClipboard, hWin ;hEdit2 changed to hWin, same as above, wrong handle

      .IF eax
        INVOKE GlobalAlloc, GMEM_MOVEABLE or GMEM_DDESHARE, SIZEOF ProgOutput

        .IF eax != NULL
          push eax
          push eax

          INVOKE GlobalLock, eax
          mov edi, eax
          mov esi, OFFSET ProgOutput
          mov ecx, SIZEOF ProgOutput
          rep movsb
          pop eax
          INVOKE GlobalUnlock, eax

          INVOKE EmptyClipboard
          pop eax
          INVOKE SetClipboardData, CF_TEXT, eax ;ADDR ProgOutput changed to CF_TEXT
        .ENDIF

        INVOKE CloseClipboard
      .ENDIF

    .ENDIF

           .endif

     .elseif uMsg == WM_CLOSE

             invoke EndDialog,hWin,NULL
     .endif

exit:          xor eax, eax
             ret

WndProc endp

strdec2bin PROC lpBuffer:DWORD, lpSource:DWORD

mov eax, lpBuffer ;eax holds the pointer to the buffer
xor ecx, ecx ;ecx=0
sub ecx, 1 ;ecx=-1

@@:inc ecx ;LOOP ecx
bt lpSource, ecx ;the bit test instruction goes here
adc byte ptr [eax+ecx], 48 ;if carryflag=1 then bit=1, else bit=0
cmp ecx, 8 ;compare with 8 bits
jne @B ;if not back

ret
strdec2bin ENDP

AboutProc proc hWin   :DWORD,
           uMsg   :DWORD,
           wParam :DWORD,
           lParam :DWORD

.if uMsg == WM_INITDIALOG

invoke LoadIcon,hInstance,100
invoke SendMessage,hWin,WM_SETICON,ICON_BIG,eax

invoke SetDlgItemText,hWin,124,offset MsgAbout
jmp exit2

.elseif uMsg == WM_COMMAND

           .if  wParam == 126

		invoke EndDialog,hWin,NULL

           .endif

.elseif uMsg == WM_CLOSE

	invoke EndDialog,hWin,NULL

.endif

exit2:	xor eax, eax
	ret

AboutProc endp

end start